#module
	ddim quaterniondf0,4
	ddim quaterniondf1,4
	ddim quaterniondf2,4
	ddim quaterniondf3,4
	ddim dffsvec0,3
	ddim dffsvec1,3
	ddim dfspec0,3
	ddim dfvec0,3
	ddim dfvec1,3
	ddim dfvec2,3
	ddim dfvec3,3
	ddim pixelhalf,3
	ddim c_diff,3
	ddim c_spec,3
	ddim specular_f,3
	ddim specular_brdf,3
	ddim dfnorm,3
	
#deffunc fpsinit
	second0@ = gettime(6)
	milliseconds0@ = gettime(7)
	return

#deffunc fpscalc
	second1@ = gettime(6)
	milliseconds1@ = gettime(7)
	if second1@ = second0@{
		dmilliseconds@ = milliseconds1@ - milliseconds0@
	}
	else{
		dmilliseconds@ = 1000 + milliseconds1@ - milliseconds0@
	}
	fps@ = 1000.0 / dmilliseconds@
	second0@ = second1@
	milliseconds0@ = milliseconds1@
	return

#deffunc vectorplus array pvecr,array pvec0,array pvec1
	pvecr.0 = pvec0.0 + pvec1.0
	pvecr.1 = pvec0.1 + pvec1.1
	pvecr.2 = pvec0.2 + pvec1.2
	return

#deffunc vectorminus array mvecr,array mvec0,array mvec1
	mvecr.0 = mvec0.0 - mvec1.0
	mvecr.1 = mvec0.1 - mvec1.1
	mvecr.2 = mvec0.2 - mvec1.2
	return

#defcfunc vectordot array dvec0,array dvec1
	return dvec0.0 * dvec1.0 + dvec0.1 * dvec1.1 + dvec0.2 * dvec1.2

#deffunc vectorcross array cvecr,array cvec0,array cvec1
	cvecr.0 = cvec0.1 * cvec1.2 - cvec0.2 * cvec1.1
	cvecr.1 = cvec0.2 * cvec1.0 - cvec0.0 * cvec1.2
	cvecr.2 = cvec0.0 * cvec1.1 - cvec0.1 * cvec1.0
	return

#deffunc vectorcrossnormalize array cvecr1,array cvec0b,array cvec1b
	cvecr1.0 = cvec0b.1 * cvec1b.2 - cvec0b.2 * cvec1b.1
	cvecr1.1 = cvec0b.2 * cvec1b.0 - cvec0b.0 * cvec1b.2
	cvecr1.2 = cvec0b.0 * cvec1b.1 - cvec0b.1 * cvec1b.0
	cvecr1length = sqrt(cvecr1.0 * cvecr1.0 + cvecr1.1 * cvecr1.1 + cvecr1.2 * cvecr1.2)
	cvecr1.0 /= cvecr1length
	cvecr1.1 /= cvecr1length
	cvecr1.2 /= cvecr1length
	return

#defcfunc vectorlength array lvec
	return sqrt(lvec.0 * lvec.0 + lvec.1 * lvec.1 + lvec.2 * lvec.2)

#deffunc vectornormalize array nvecr,array nvec0
	nveclength = sqrt(nvec0.0 * nvec0.0 + nvec0.1 * nvec0.1 + nvec0.2 * nvec0.2)
	nvecr.0 = nvec0.0 / nveclength
	nvecr.1 = nvec0.1 / nveclength
	nvecr.2 = nvec0.2 / nveclength
	return

#deffunc vectorminusnormalize array mnvecr,array mnvec0,array mnvec1
	vectorminus dfvec0,mnvec0,mnvec1
	vectornormalize mnvecr,dfvec0
	return

#deffunc vectormultiplyvector array bvecr,array bvec0,array bvec1
	bvecr.0 = bvec0.0 * bvec1.0
	bvecr.1 = bvec0.1 * bvec1.1
	bvecr.2 = bvec0.2 * bvec1.2
	return

#deffunc vectormultiplydbl array kvecr,double mutiplyk,array kvec0
	kvecr.0 = mutiplyk * kvec0.0
	kvecr.1 = mutiplyk * kvec0.1
	kvecr.2 = mutiplyk * kvec0.2
	return

#deffunc cameraangleroundxz double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	campos@.0 = camtargetpos@.0 + x
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraangleroundy double degstep
	x = campos@.0 - camtargetpos@.0
	y = campos@.1 - camtargetpos@.1
	z = campos@.2 - camtargetpos@.2
	r = sqrt(x * x + y * y + z * z)
	r0 = sqrt(x * x + z * z)
	theta = atan(y,r0)
	phi = atan(z,x)
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	theta += degstep
	;if theta >= 2.0 * M_PI : theta -= 2.0 * M_PI
	;r0 = r * cos(theta)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	campos@.0 = camtargetpos@.0 + x
	campos@.1 = camtargetpos@.1 + y
	campos@.2 = camtargetpos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundxz double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	theta0 = atan(z,x)
	
	theta0 += degstep
	x = r0 * cos(theta0)
	z = r0 * sin(theta0)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameratargetroundy double degstep
	x = camtargetpos@.0 - campos@.0
	y = camtargetpos@.1 - campos@.1
	z = camtargetpos@.2 - campos@.2
	
	r0 = sqrt(x * x + z * z)
	phi = atan(z,x)
	r = sqrt(x * x + y * y + z * z)
	theta = atan(y,r0)
	theta += degstep
	xmax = r * cos(phi)
	zmax = r * sin(phi)
	y = r * sin(theta)
	x = xmax * cos(theta)
	z = zmax * cos(theta)
	camtargetpos@.0 = campos@.0 + x
	camtargetpos@.1 = campos@.1 + y
	camtargetpos@.2 = campos@.2 + z
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovex double camerastep	
	campos@.0 += camerastep
	camtargetpos@.0 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return
	
#deffunc cameramovey double camerastep	
	campos@.1 += camerastep
	camtargetpos@.1 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameramovez double camerastep	
	campos@.2 += camerastep
	camtargetpos@.2 += camerastep
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#deffunc cameraposforward  double camerastep
	vectorminus camvec@,camtargetpos@,campos@
	camveclength = vectorlength(camvec@)
	vectormultiplydbl tempvec@,camerastep / camveclength,camvec@
	campos@.0 += tempvec@.0
	campos@.1 += tempvec@.1
	campos@.2 += tempvec@.2
	camtargetpos@.0 += tempvec@.0
	camtargetpos@.1 += tempvec@.1
	camtargetpos@.2 += tempvec@.2
	viewmatrixset campos@.0,campos@.1,campos@.2,camtargetpos@.0,camtargetpos@.1,camtargetpos@.2,upvecx@,upvecy@,upvecz@
	return

#defcfunc dist2p double xd0,double yd0,double zd0,double xd1,double yd1,double zd1
	return sqrt((xd1 - xd0) * (xd1 - xd0) + (yd1 - yd0) * (yd1 - yd0) + (zd1 - zd0) * (zd1 - zd0))
	
#defcfunc dist2pxz double xd2,double zd2,double xd3,double zd3
	return sqrt((xd3 - xd2) * (xd3 - xd2) + (zd3 - zd2) * (zd3 - zd2))

#deffunc quaterniontransform array dfquater,array vtx0
	quaterniondf0.0 = -dfquater.0
	quaterniondf0.1 = -dfquater.1
	quaterniondf0.2 = -dfquater.2
	quaterniondf0.3 = dfquater.3

	quaterniondf1.0 = vtx0.0
	quaterniondf1.1 = vtx0.1
	quaterniondf1.2 = vtx0.2
	quaterniondf1.3 = 0.0
	
	quaternionmultiply quaterniondf2,quaterniondf1,quaterniondf0
	quaternionmultiply quaterniondf0,dfquater,quaterniondf2

	vtx0.0 = quaterniondf0.0
	vtx0.1 = quaterniondf0.1
	vtx0.2 = quaterniondf0.2
	return

#deffunc quaterniontransform1 array vtx2,array dfquater1,array vtx1
	quaterniondf0.0 = -dfquater1.0
	quaterniondf0.1 = -dfquater1.1
	quaterniondf0.2 = -dfquater1.2
	quaterniondf0.3 = dfquater1.3

	quaterniondf1.0 = vtx1.0
	quaterniondf1.1 = vtx1.1
	quaterniondf1.2 = vtx1.2
	quaterniondf1.3 = 0.0
	
	quaternionmultiplyw0 quaterniondf2,quaterniondf1,quaterniondf0
	quaternionmultiply quaterniondf0,dfquater1,quaterniondf2

	vtx2.0 = quaterniondf0.0
	vtx2.1 = quaterniondf0.1
	vtx2.2 = quaterniondf0.2
	return

#deffunc quaternionmultiply array rot4a,array rot4b,array rot4c
	rot4a.0 = rot4b.3 * rot4c.0 + rot4b.0 * rot4c.3 + rot4b.1 * rot4c.2 - rot4b.2 * rot4c.1
	rot4a.1 = rot4b.3 * rot4c.1 + rot4b.1 * rot4c.3 + rot4b.2 * rot4c.0 - rot4b.0 * rot4c.2
	rot4a.2 = rot4b.3 * rot4c.2 + rot4b.2 * rot4c.3 + rot4b.0 * rot4c.1 - rot4b.1 * rot4c.0
	rot4a.3 = rot4b.3 * rot4c.3 - rot4b.0 * rot4c.0 - rot4b.1 * rot4c.1 - rot4b.2 * rot4c.2
	return

#deffunc quaternionmultiplyw0 array rot5a,array rot5b,array rot5c
	rot5a.0 = rot5b.0 * rot5c.3 + rot5b.1 * rot5c.2 - rot5b.2 * rot5c.1
	rot5a.1 = rot5b.1 * rot5c.3 + rot5b.2 * rot5c.0 - rot5b.0 * rot5c.2
	rot5a.2 = rot5b.2 * rot5c.3 + rot5b.0 * rot5c.1 - rot5b.1 * rot5c.0
	rot5a.3 = rot5b.0 * rot5c.0 - rot5b.1 * rot5c.1 - rot5b.2 * rot5c.2
	return

#deffunc setquaternxyztheta array rot4d,array dfnvec,double dftheta
	rot4d.0 = dfnvec.0 * sin(0.5 * dftheta)
	rot4d.1 = dfnvec.1 * sin(0.5 * dftheta)
	rot4d.2 = dfnvec.2 * sin(0.5 * dftheta)
	rot4d.3 = cos(0.5 * dftheta)
	return



#deffunc mat44xmat44 array mat44r,array mat44a,array mat44b
	mat44r.0 = mat44a.0 * mat44b.0 + mat44a.1 * mat44b.4 + mat44a.2 * mat44b.8 + mat44a.3 * mat44b.12
	mat44r.1 = mat44a.0 * mat44b.1 + mat44a.1 * mat44b.5 + mat44a.2 * mat44b.9 + mat44a.3 * mat44b.13
	mat44r.2 = mat44a.0 * mat44b.2 + mat44a.1 * mat44b.6 + mat44a.2 * mat44b.10 + mat44a.3 * mat44b.14
	mat44r.3 = mat44a.0 * mat44b.3 + mat44a.1 * mat44b.7 + mat44a.2 * mat44b.11 + mat44a.3 * mat44b.15

	mat44r.4 = mat44a.4 * mat44b.0 + mat44a.5 * mat44b.4 + mat44a.6 * mat44b.8 + mat44a.7 * mat44b.12
	mat44r.5 = mat44a.4 * mat44b.1 + mat44a.5 * mat44b.5 + mat44a.6 * mat44b.9 + mat44a.7 * mat44b.13
	mat44r.6 = mat44a.4 * mat44b.2 + mat44a.5 * mat44b.6 + mat44a.6 * mat44b.10 + mat44a.7 * mat44b.14
	mat44r.7 = mat44a.4 * mat44b.3 + mat44a.5 * mat44b.7 + mat44a.6 * mat44b.11 + mat44a.7 * mat44b.15

	mat44r.8 = mat44a.8 * mat44b.0 + mat44a.9 * mat44b.4 + mat44a.10 * mat44b.8 + mat44a.11 * mat44b.12
	mat44r.9 = mat44a.8 * mat44b.1 + mat44a.9 * mat44b.5 + mat44a.10 * mat44b.9 + mat44a.11 * mat44b.13
	mat44r.10 = mat44a.8 * mat44b.2 + mat44a.9 * mat44b.6 + mat44a.10 * mat44b.10 + mat44a.11 * mat44b.14
	mat44r.11 = mat44a.8 * mat44b.3 + mat44a.9 * mat44b.7 + mat44a.10 * mat44b.11 + mat44a.11 * mat44b.15

	mat44r.12 = mat44a.12 * mat44b.0 + mat44a.13 * mat44b.4 + mat44a.14 * mat44b.8 + mat44a.15 * mat44b.12
	mat44r.13 = mat44a.12 * mat44b.1 + mat44a.13 * mat44b.5 + mat44a.14 * mat44b.9 + mat44a.15 * mat44b.13
	mat44r.14 = mat44a.12 * mat44b.2 + mat44a.13 * mat44b.6 + mat44a.14 * mat44b.10 + mat44a.15 * mat44b.14
	mat44r.15 = mat44a.12 * mat44b.3 + mat44a.13 * mat44b.7 + mat44a.14 * mat44b.11 + mat44a.15 * mat44b.15
	return
	
#deffunc vec4xmat44 array vec4r,array vec4a,array mat44c
	vec4r.0 = vec4a.0 * mat44c.0 + vec4a.1 * mat44c.4 + vec4a.2 * mat44c.8 + vec4a.3 * mat44c.12
	vec4r.1 = vec4a.0 * mat44c.1 + vec4a.1 * mat44c.5 + vec4a.2 * mat44c.9 + vec4a.3 * mat44c.13
	vec4r.2 = vec4a.0 * mat44c.2 + vec4a.1 * mat44c.6 + vec4a.2 * mat44c.10 + vec4a.3 * mat44c.14
	vec4r.3 = vec4a.0 * mat44c.3 + vec4a.1 * mat44c.7 + vec4a.2 * mat44c.11 + vec4a.3 * mat44c.15
	return

#deffunc vec3xmat33 array vec3r,array vec3a,array mat33a
	vec3r.0 = vec3a.0 * mat33a.0 + vec3a.1 * mat33a.3 + vec3a.2 * mat33a.6
	vec3r.1 = vec3a.0 * mat33a.1 + vec3a.1 * mat33a.4 + vec3a.2 * mat33a.7
	vec3r.2 = vec3a.0 * mat33a.2 + vec3a.1 * mat33a.5 + vec3a.2 * mat33a.8
	return
	
#deffunc perspectivefovlh
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec0,dfvec2,dfvec1
	vectorcross dfvec2,dfvec1,dfvec0
	
	matview@.0 = dfvec0.0
	matview@.1 = dfvec2.0
	matview@.2 = dfvec1.0
	matview@.3 = 0.0
	
	matview@.4 = dfvec0.1
	matview@.5 = dfvec2.1
	matview@.6 = dfvec1.1
	matview@.7 = 0.0
	
	matview@.8 = dfvec0.2
	matview@.9 = dfvec2.2
	matview@.10 = dfvec1.2
	matview@.11 = 0.0
	
	matview@.12 = -(dfvec0.0 * campos@.0 + dfvec0.1 * campos@.1 + dfvec0.2 * campos@.2)
	matview@.13 = -(dfvec2.0 * campos@.0 + dfvec2.1 * campos@.1 + dfvec2.2 * campos@.2)
	matview@.14 = -(dfvec1.0 * campos@.0 + dfvec1.1 * campos@.1 + dfvec1.2 * campos@.2)
	matview@.15 = 1.0
	return

#deffunc perspectivefovlhinv
	vectorminus dfvec0,camtargetpos@,campos@
	vectornormalize dfvec1,dfvec0
	dfvec2(0) = upvecx@
	dfvec2(1) = upvecy@
	dfvec2(2) = upvecz@
	vectorcrossnormalize dfvec0,dfvec2,dfvec1
	vectorcross dfvec2,dfvec1,dfvec0
	
	matviewinv@.0 = dfvec0.0
	matviewinv@.1 = dfvec0.1
	matviewinv@.2 = dfvec0.2
	matviewinv@.3 = 0.0
	
	matviewinv@.4 = dfvec2.0
	matviewinv@.5 = dfvec2.1
	matviewinv@.6 = dfvec2.2
	matviewinv@.7 = 0.0
	
	matviewinv@.8 = dfvec1.0
	matviewinv@.9 = dfvec1.1
	matviewinv@.10 = dfvec1.2
	matviewinv@.11 = 0.0
	
	matviewinv@.12 = campos@.0
	matviewinv@.13 = campos@.1
	matviewinv@.14 = campos@.2
	matviewinv@.15 = 1.0
	return

#defcfunc determinant22 array gr0
	return gr.0 * gr.3 - gr.1 * gr.2
	
#deffunc fresnel_shlick3 array fsreturnvec,array fsvec0,array fsvec90,double fsx
	vectorminus dffsvec0,fsvec90,fsvec0
	vectormultiplydbl dffsvec1,powf(1.0 - fsx, 5),dffsvec0
	vectorplus fsreturnvec,fsvec0,dffsvec1
	return

#defcfunc diffuse_burley double dbndotl,double dbndotv,double dbldoth,double dbroughness
	fd90 = 0.5 + 2.0 * dbroughness * dbldoth * dbldoth
	return (1.0 + (fd90 - 1.0)  * powf(1.0 - dbndotl, 5)) * (1.0 + (fd90 - 1.0)  * powf(1.0 - dbndotv, 5))

#defcfunc specular_d_ggx double d_ggxalpha,double d_ggxndoth
	d_ggxalpha2 = d_ggxalpha * d_ggxalpha
	lower = (d_ggxndoth * d_ggxndoth * (d_ggxalpha2 - 1)) + 1
	if 0.000001 > M_PI * lower * lower{
		return d_ggxalpha2 / 0.000001
	}
	else{
		return d_ggxalpha2 / (M_PI * lower * lower)
	}

#defcfunc g_shlick_smith_hable double gshalpha, double gshldoth
	gshldoth2 = gshldoth * gshldoth
	dfk = gshldoth2 + (1.0 - gshldoth2) * gshalpha * gshalpha * 0.25
    return 1.0 / dfk

#defcfunc v_smith double vsalpha, double vsndotl, double vsndotv
	vsalpha2 = vsalpha * vsalpha
	lambdav = vsndotl * sqrt(vsndotv * vsndotv * (1.0 - vsalpha2) + vsalpha2)
	lambdal = vsndotv * sqrt(vsndotl * vsndotl * (1.0 - vsalpha2) + vsalpha2)
	return 0.5 / (lambdav + lambdal + 0.0001)

#defcfunc v_smith1 double vsalpha1, double vsndotl1, double vsndotv1
	lambdav1 = vsndotl1 * (vsndotv1 * (1.0 - vsalpha1) + vsalpha1)
	lambdal1 = vsndotv1 * (vsndotl1 * (1.0 - vsalpha1) + vsalpha1)
	return 0.5 / (lambdav1 + lambdal1 + 0.0001)

#deffunc lerp3 array lerp3r,array lerp3a,array lerp3b,double lerp3s
	lerp3r.0 = lerp3a.0 + lerp3s * (lerp3b.0 - lerp3a.0)
	lerp3r.1 = lerp3a.1 + lerp3s * (lerp3b.1 - lerp3a.1)
	lerp3r.2 = lerp3a.2 + lerp3s * (lerp3b.2 - lerp3a.2)
	return



#deffunc mesarray array mesarray0
	mes "x = " + str(mesarray0.0) + "y = " + str(mesarray0.1) + "z = " + str(mesarray0.2)
	return

#deffunc pixelpbrcalc array dfacccolor,array pixelview,array pixelnorm,array pixellight,array pixelalbedo,double pixelmetal,double pixelrough,array lightcolor
	vectorplus dfvec0,pixelview,pixellight
	vectornormalize pixelhalf,dfvec0
	dfndotv = limitf(vectordot(pixelnorm,pixelview),0.0,1.0)
	dfndoth = limitf(vectordot(pixelnorm,pixelhalf),0.0,1.0)
	dfldoth = limitf(vectordot(pixellight,pixelhalf),0.0,1.0)
	dfndotl = limitf(vectordot(pixelnorm,pixellight),0.0,1.0)
	dfalpha = pixelrough * pixelrough
	lerp3 c_diff,pixelalbedo,vec000@,pixelmetal
	lerp3 c_spec,vec040404@,pixelalbedo,pixelmetal
	diffuse_factor = diffuse_burley(dfndotl,dfndotv,dfldoth,pixelrough)
	specular_d = specular_d_ggx(dfalpha,dfndoth)
	fresnel_shlick3 specular_f,c_spec,vec111@,dfldoth
	specular_g = g_shlick_smith_hable(dfalpha,dfldoth)
	vectormultiplydbl specular_brdf,specular_d * specular_g,specular_f
	vectormultiplydbl dfvec0,diffuse_factor,c_diff
	vectorplus dfvec1,dfvec0,specular_brdf
	vectormultiplydbl dfvec2,dfndotl,dfvec1
	vectormultiplyvector dfacccolor,lightcolor,dfvec2
	return

#deffunc pixelpbrintensity array dfacccolor1,array pixelview1,array pixelnorm1,array pixellight1,array pixelalbedo1,double pixelmetal1,double pixelrough1
	vectorplus dfvec0,pixelview1,pixellight1
	vectornormalize pixelhalf,dfvec0
	dfndotv = limitf(vectordot(pixelnorm1,pixelview1),0.0,1.0)
	dfndoth = limitf(vectordot(pixelnorm1,pixelhalf),0.0,1.0)
	dfldoth = limitf(vectordot(pixellight1,pixelhalf),0.0,1.0)
	dfndotl = limitf(vectordot(pixelnorm1,pixellight1),0.0,1.0)
	dfalpha = pixelrough1 * pixelrough1
	lerp3 c_diff,pixelalbedo1,vec000@,pixelmetal1
	lerp3 c_spec,vec040404@,pixelalbedo1,pixelmetal1
	diffuse_factor = diffuse_burley(dfndotl,dfndotv,dfldoth,pixelrough1)
	specular_d = specular_d_ggx(dfalpha,dfndoth)
	fresnel_shlick3 specular_f,c_spec,vec111@,dfldoth
	specular_g = g_shlick_smith_hable(dfalpha,dfldoth)
	vectormultiplydbl specular_brdf,specular_d * specular_g,specular_f
	vectormultiplydbl dfvec0,diffuse_factor,c_diff
	vectorplus dfvec1,dfvec0,specular_brdf
	vectormultiplydbl dfacccolor1,dfndotl,dfvec1
	
	return

#deffunc brdfshere int c0x,int c0y,int rshere
	repeat 2 * rshere
	dfycnt = c0y - rshere + cnt
	yshere = double(dfycnt - c0y)
		repeat 2 * rshere
		dfxcnt = c0x - rshere + cnt
		xshere = double(dfxcnt - c0x)
		if xshere * xshere + yshere * yshere < double(rshere * rshere){
			zshere = sqrt(double(rshere * rshere) - xshere * xshere - yshere * yshere)
			dfvec0(0) = xshere
			dfvec0(1) = -yshere
			dfvec0(2) = -zshere
			vectornormalize dfnorm,dfvec0
			pixelpbrcalc c_output@,vvec@,dfnorm,lvec@,albedo@,metallic@,roughness@,vec111@
			dfr = int(limitf(c_output@.0,0.0,1.0) * 255.0)
			dfg = int(limitf(c_output@.1,0.0,1.0) * 255.0)
			dfb = int(limitf(c_output@.2,0.0,1.0) * 255.0)
			poke vramsc0@,3 * (dfxcnt + (scheight@ - dfycnt - 1) * scwidth@),dfb
			poke vramsc0@,3 * (dfxcnt + (scheight@ - dfycnt - 1) * scwidth@) + 1,dfg
			poke vramsc0@,3 * (dfxcnt + (scheight@ - dfycnt - 1) * scwidth@) + 2,dfr
			
		}
		loop
	loop
	return


