import bmesh,bpy,mathutils,math

for o in bpy.data.objects:
    if o.type == "MESH":
         bpy.context.view_layer.objects.active = o
bpy.ops.object.mode_set(mode = 'EDIT')
bm = bmesh.from_edit_mesh(bpy.context.object.data)
obj = bpy.context.object
file = open('E:\\blenderfile\\fordx12tfb\\inutam1.txt','w')

file.write('material{0:d};\n'.format(len(obj.data.materials)))
mathavetex = []
for i in range(0,len(obj.data.materials)):
    file.write(str(i)+';')
    
    for j in range(0,len(obj.data.materials[i].node_tree.nodes)):
        if obj.data.materials[i].node_tree.nodes[j].type == 'BSDF_PRINCIPLED':
            nbsdf = obj.data.materials[i].node_tree.nodes[j]
            continue
        if obj.data.materials[i].node_tree.nodes[j].type == 'SEPARATE_COLOR':
            separeteclr = obj.data.materials[i].node_tree.nodes[j]
            
    havebasetex = 0
    havemrctex = 0
    havenormtex = 0
    
    for l in obj.data.materials[i].node_tree.links:
        if l.from_node.type == 'TEX_IMAGE':
            if l.to_socket == nbsdf.inputs[0]:
                havebasetex = 1
                basetex = l.from_node
        if l.from_node.type == 'TEX_IMAGE':
            if l.to_node.type == 'SEPARATE_COLOR':
                havemrctex = 1
                mrtex = l.from_node
        if l.from_node.type == 'TEX_IMAGE':
            if l.to_node.type == 'NORMAL_MAP':
                havenormtex = 1
                normtex = l.from_node
    
    matkind = 100 * havebasetex + 10 * havemrctex + havenormtex
    file.write('{0:d};'.format(matkind))
        
    if havebasetex == 0:
        file.write('Base({0:.4f},{1:.4f},{2:.4f});'.format(nbsdf.inputs["Base Color"].default_value[0],nbsdf.inputs["Base Color"].default_value[1],nbsdf.inputs["Base Color"].default_value[2]))
    else:
        file.write("Base(1.0000,1.0000,1.0000);")
    file.write('Alph({0:.4f});'.format(nbsdf.inputs["Alpha"].default_value))
    
    if havemrctex == 0:
        file.write('Metallic({0:.4f});'.format(nbsdf.inputs["Metallic"].default_value))
        file.write('Roughness({0:.4f});'.format(nbsdf.inputs["Roughness"].default_value))
        file.write('Clearcoat({0:.4f});'.format(nbsdf.inputs["Clearcoat"].default_value))
    else:
        file.write("Metallic(1.0000);")
        file.write("Roughness(1.0000);")
        file.write("Clearcoat(1.0000);")
        
    
    if havebasetex == 0:
        file.write('None;')
    else:
        file.write(basetex.image.name+";")
        
    if havemrctex == 0:
        file.write('None;')
    else:
        file.write(mrtex.image.name+";")
        
    if havenormtex == 0:
        file.write('None;')
    else:
        file.write(normtex.image.name+";")
    
    file.write(obj.data.materials[i].name+';')
    file.write('\n')
    mathavetex.append(matkind)
    

facevertexlist = []
for f in bm.faces:        
    s = str(f.material_index) + ';'
    l0 = f.loops[0]
    s += str(l0.vert.index) + ';'
    if mathavetex[f.material_index] == 0:
        s += '0.0000;0.0000;'
    else:
        s += '{0:.4f};{1:.4f};'.format(l0[bm.loops.layers.uv.active].uv.x,1.0-l0[bm.loops.layers.uv.active].uv.y)
    if f.smooth == True:
        s += '-1;'
    else:
        s += str(f.index) + ';'
    facevertexlist.append(s)
    #file.write(s)
    #file.write('\n')
    
    s = str(f.material_index) + ';'
    l2 = f.loops[2]
    s += str(l2.vert.index) + ';'
    if mathavetex[f.material_index] == 0:
        s += '0.0000;0.0000;'
    else:
        s += '{0:.4f};{1:.4f};'.format(l2[bm.loops.layers.uv.active].uv.x,1.0-l2[bm.loops.layers.uv.active].uv.y)
    if f.smooth == True:
        s += '-1;'
    else:
        s += str(f.index) + ';'
    facevertexlist.append(s)
    #file.write(s)
    #file.write('\n')
    
    s = str(f.material_index) + ';'
    l1 = f.loops[1]
    s += str(l1.vert.index) + ';'
    if mathavetex[f.material_index] == 0:
        s += '0.0000;0.0000;'
    else:
        s += '{0:.4f};{1:.4f};'.format(l1[bm.loops.layers.uv.active].uv.x,1.0-l1[bm.loops.layers.uv.active].uv.y)
    if f.smooth == True:
        s += '-1;'
    else:
        s += str(f.index) + ';'
    facevertexlist.append(s)
    #file.write(s)
    #file.write('\n')
    
#file.write(str(len(facevertexlist)))
#file.write('\n')
facevertex_unique = list(set(facevertexlist))
#file.write(str(len(facevertex_unique)))
#file.write('\n')

newfacevertexno = []
for i in range(0,len(facevertexlist)):
    for j in range(0,len(facevertex_unique)):
        if facevertexlist[i] == facevertex_unique[j]:
            newfacevertexno.append(j)
            break
#file.write(str(len(newfacevertexno)))
#file.write('\n')


file.write('vert{0:d};\n'.format(len(facevertex_unique)))
for i in range(0,len(facevertex_unique)):
    vtxdata = facevertex_unique[i].split(';')
    bldvtxno = int(vtxdata[1])
    if vtxdata[4] == '-1':
        file.write('{0:d};{1:d};co({2:.5f},{3:.5f},{4:.5f});norm({5:.5f},{6:.5f},{7:.5f});{8};uv({9},{10});\n'.format(i,bldvtxno,\
        bm.verts[bldvtxno].co.x,bm.verts[bldvtxno].co.z,bm.verts[bldvtxno].co.y,\
        bm.verts[bldvtxno].normal.x,bm.verts[bldvtxno].normal.z,bm.verts[bldvtxno].normal.y,\
        vtxdata[0],vtxdata[2],vtxdata[3]))
    else:
        faceno = int(vtxdata[4])
        v01 = bm.verts[bm.faces[faceno].loops[1].vert.index].co - bm.verts[bm.faces[faceno].loops[0].vert.index].co
        v02 = bm.verts[bm.faces[faceno].loops[2].vert.index].co - bm.verts[bm.faces[faceno].loops[0].vert.index].co
        v3 = v01.cross(v02)
        n3 = v3.normalized()
        file.write('{0:d};{1:d};co({2:.5f},{3:.5f},{4:.5f});norm({5:.5f},{6:.5f},{7:.5f});{8};uv({9},{10});\n'.format(i,bldvtxno,\
        bm.verts[bldvtxno].co.x,bm.verts[bldvtxno].co.z,bm.verts[bldvtxno].co.y,\
        n3.x,n3.z,n3.y,vtxdata[0],vtxdata[2],vtxdata[3]))
        
file.write('face{0:d};\n'.format(len(bm.faces)))
for i in range(0,len(bm.faces)):
    if bm.faces[i].smooth == True:
        j = 1
    else:
        j = 0
    file.write('{0:d};{1:d};{2:d};{3:d};{4:d};\n'.format(i,newfacevertexno[3 * i],\
    newfacevertexno[3 * i + 1],newfacevertexno[3 * i + 2],j))

    

existarmature = 0
for o in bpy.data.objects:
    if o.type == "ARMATURE":
        existarmature = 1
        break
    
if existarmature == 1:
    file.write('armature{0:d};\n'.format(len(o.data.bones)))
    for i in range(0,len(o.data.bones)):
        b = o.data.bones[i]
        if i == 0:
            file.write(str(i)+';(-1);')
        else:
            for j in range(0,len(o.data.bones)):
                if b.parent.name == o.data.bones[j].name:
                    file.write(str(i)+';('+str(j)+');')
                    break
        vertexcaft = o.matrix_world @ b.head_local
        file.write('head({0:.4f},{1:.4f},{2:.4f});'.format(vertexcaft[0],vertexcaft[2],vertexcaft[1]))
        vertexcaft = o.matrix_world @ b.tail_local
        file.write('tail({0:.4f},{1:.4f},{2:.4f});'.format(vertexcaft[0],vertexcaft[2],vertexcaft[1]))
        
        file.write(b.name+';')
        if b.use_connect == True:
            file.write('c;')
        else:
            file.write('s;')
        
        file.write('\n')
        
    file.write('vertweight{0:d};\n'.format(len(bm.verts)))
    vertexgrouptobone = []
    numbbox = 0
    for m in range(0,len(obj.vertex_groups)):
        bonevertexgroupornot = 0
        for n in range(0,len(o.data.bones)):
            if obj.vertex_groups[m].name == o.data.bones[n].name:
                vertexgrouptobone.append(n)
                bonevertexgroupornot = 1
                #file.write('{0:d};{1};{2:d};{3};\n'.format(m,obj.vertex_groups[m].name,n,o.data.bones[n].name))
                break
        if bonevertexgroupornot == 0:
            vertexgrouptobone.append(-1)
            numbbox += 1
        
    for v in bm.verts:
        file.write('{0:d};'.format(v.index))
        dvert = v[bm.verts.layers.deform.active]
        ngi = 0
        str0 = ''
        for gi in range(0,len(obj.vertex_groups) - numbbox):
            if gi in dvert:
                ngi += 1
                str0 += '('+str(vertexgrouptobone[gi])+':{0:.4f});'.format(dvert[gi])
        file.write('B'+str(ngi)+';'+str0)
        file.write('\n')

if existarmature == 1 and hasattr(o.animation_data.action,'fcurves'):
    motionpoint = []
    for mp in o.animation_data.action.fcurves[0].keyframe_points:
        motionpoint.append(int(mp.co[0]))
          
    file.write('animdata{0:d};\n'.format(len(motionpoint)))
    for i in range(0,len(motionpoint)):
        file.write(str(motionpoint[i])+';')
    file.write('\n')
    
    defaultxaxis = []
    defaultyaxis = []
    defaultzaxis = []
    bpy.context.scene.frame_set(1)
    for i in range(0,len(o.pose.bones)):
        defaultxaxis.append(o.pose.bones[i].x_axis)
        defaultyaxis.append(o.pose.bones[i].y_axis)
        defaultzaxis.append(o.pose.bones[i].z_axis)
    
    for f in motionpoint:
        bpy.context.scene.frame_set(f)
        for i in range(0,len(o.pose.bones)):
            pbone = o.pose.bones[i]
            
            oldloc = pbone.location
            loc = oldloc[0] * defaultxaxis[i] + oldloc[1] * defaultyaxis[i] + oldloc[2] * defaultzaxis[i]
            
            oldrot = pbone.rotation_quaternion
            sinht = (1 - oldrot[0] ** 2) ** 0.5
            if sinht != 0.0 :
                nxold = oldrot[1] / sinht
                nyold = oldrot[2] / sinht
                nzold = oldrot[3] / sinht
                nvec = nxold * defaultxaxis[i] + nyold * defaultyaxis[i] + nzold * defaultzaxis[i]
                rot = mathutils.Quaternion((oldrot[0],sinht * nvec[0],sinht * nvec[1],sinht * nvec[2]))
            else:
                rot = oldrot
            #oldscale = pbone.scale
            scale = pbone.scale
            #scale = oldscale[0] * defaultxaxis[i] + oldscale[1] * defaultyaxis[i] + oldscale[2] * defaultzaxis[i]
            file.write('{0:d};{1:d};loc({2:.5f},{3:.5f},{4:.5f});rot({5:.5f},{6:.5f},{7:.5f},{8:.5f});scl({9:.5f});\n'.format(f,i,loc[0],loc[2],loc[1],rot[0],rot[1],rot[3],rot[2],(scale[0] + scale[1] + scale[2]) / 3.0))
            
numbbox = 0
firstbboxindex = -1
for m in range(0,len(obj.vertex_groups)):
    if 'bbox' in obj.vertex_groups[m].name:
        firstbboxindex = m
        break
        
#file.write('firstbboxindex {0:d}'.format(firstbboxindex))
#file.write('obj.vertex_groups {0:d}'.format(len(obj.vertex_groups)))
if firstbboxindex >= 0:
    for gi in range(firstbboxindex,len(obj.vertex_groups)):
        numvtxinbbox = 0
        str0 = ''
        for v in bm.verts:
            dvert = v[bm.verts.layers.deform.active]
            if gi in dvert:
                numvtxinbbox += 1
                str0 += '{0:d}'.format(v.index)
                str0 += '\n'
        
        file.write(obj.vertex_groups[gi].name)
        file.write('\n')
        file.write('({0:d})'.format(numvtxinbbox))
        file.write('\n')
        file.write(str0)
        
file.close()