Texture2D <float4> texwvp:register(t0);
Texture2D texdif0:register(t1);
Texture2D texdif1:register(t2);
Texture2D texdif2:register(t3);
Texture2D texdif3:register(t4);
Texture2D texdif4:register(t5);
Texture2D <float4> texmat:register(t6);
Texture2D texnorm0:register(t7);
Texture2D texnorm1:register(t8);
Texture2D texnorm2:register(t9);
Texture2D texnorm3:register(t10);
Texture2D texnorm4:register(t11);
Texture2D texmrcw0:register(t12);
Texture2D texmrcw1:register(t13);
Texture2D texmrcw2:register(t14);
Texture2D texmrcw3:register(t15);
Texture2D texmrcw4:register(t16);

SamplerState smp:register(s0);

cbuffer WVPdata : register(b0) {
	matrix worldMat            : packoffset(c0);
	matrix wvpMat            : packoffset(c4);
	float3 pointlightpos            : packoffset(c8);
	int paramint0 : packoffset(c8.w);
	float3 camerapos            : packoffset(c9);
	float paramfloat0 : packoffset(c9.w);
	float3 toLightDirection[3]        : packoffset(c10);
	float3 LightColor[3]            : packoffset(c13);
};
cbuffer Animdata : register(b1) {
	matrix animmat[72];
};
cbuffer cbuff2 : register(b2) {
	float4 wavefacecolor;
	float4 wavespeccolor;
	float4 waveemiccolor;
	float4 woc0;
	float4 woc1;
	float4 woc2;
	float timefloat;
	float pixel1uv;
	float bunbowl0;
	float bunbowl1;
	float bunbowl2;
	float a0;
	float a1;
	float a2;
	float vx;
	float vy;
	float wavepower;
	float ka;
};
cbuffer CBSpriteData : register(b3)
{
	float4 spvtxpos[4];
	float4 spvtxtex[4];
};
cbuffer CBParticleData : register(b4)
{
	float ptldata[512];
};

struct inputBasicType {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
	float3 norm : NORMAL;
	uint matno : MATNO;
	int joint0 : JOINTNO0;
	float weight0 : WEIGHT0;
	int joint1 : JOINTNO1;
};
struct BasicType {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
	float3 norm : NORMAL;
	float3 posworld : POSWORLD;
	uint matno : MATNO;
};
struct inputBasicTypenm {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
	float3 norm : NORMAL;
	uint matno : MATNO;
	float3 uvec:UVECTOR;
	float3 vvec:VVECTOR;
};
struct BasicTypenm {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
	float3 norm : NORMAL;
	float3 posworld : POSWORLD;
	uint matno : MATNO;
	float3 uvec:UVECTOR;
	float3 vvec:VVECTOR;
};
struct BasicTypesp {
	float4 svpos:SV_POSITION;//VXep_W
	float2 uv:TEXCOORD;//UVl
};
struct BasicTypeptl {
	float3 pos:POSITION;
	float2 uv : TEXCOORD;
};



float dzdx(float uf1, float vf1)
{
	/*float timefloat = 0.0;
	float4 woc0 = float4(-0.195, -0.195, 0.0, 0.0);
	float4 woc1 = float4(1.195, -0.195, 0.0, 0.0);
	float4 woc2 = float4(0.5, 0.5, 0.0, 0.0);
	float pixel1uv = 0.0039;
	float bunbowl0 = 10.24;
	float bunbowl1 = 17.06;
	float bunbowl2 = 25.6;
	float a0 = 0.5;
	float a1 = 0.4;
	float a2 = 0.7;*/
	float3 uvz = float3(uf1, vf1, 0.0);
	float r0 = length(uvz - woc0.xyz);
	float r1 = length(uvz - woc1.xyz);
	float r2 = length(uvz - woc2.xyz);
	float angletime = timefloat * 62.8;
	return a0 * 6.28 * bunbowl0 * cos(6.28 * r0 * bunbowl0 - angletime) * (uvz.x - woc0.x) / r0
		+ a1 * 6.28 * bunbowl1 * cos(6.28 * r1 * bunbowl1 - angletime) * (uvz.x - woc1.x) / r1
		+ a2 * 6.28 * bunbowl2 * cos(6.28 * r2 * bunbowl1 - angletime) * (uvz.x - woc2.x) / r2;
}
float dzdy(float uf2, float vf2)
{
	/*float timefloat = 0.0;
	float4 woc0 = float4(-0.195, -0.195, 0.0, 0.0);
	float4 woc1 = float4(1.195, -0.195, 0.0, 0.0);
	float4 woc2 = float4(0.5, 0.5, 0.0, 0.0);
	float pixel1uv = 0.0039;
	float bunbowl0 = 10.24;
	float bunbowl1 = 17.06;
	float bunbowl2 = 25.6;
	float a0 = 0.5;
	float a1 = 0.4;
	float a2 = 0.7;*/
	float3 uvz = float3(uf2, vf2, 0.0);
	float r0 = length(uvz - woc0.xyz);
	float r1 = length(uvz - woc1.xyz);
	float r2 = length(uvz - woc2.xyz);
	float angletime = timefloat * 62.8;
	return a0 * 6.28 * bunbowl0 * cos(6.28 * r0 * bunbowl0 - angletime) * (uvz.y - woc0.y) / r0
		+ a1 * 6.28 * bunbowl1 * cos(6.28 * r1 * bunbowl1 - angletime) * (uvz.y - woc1.y) / r1
		+ a2 * 6.28 * bunbowl2 * cos(6.28 * r2 * bunbowl1 - angletime) * (uvz.y - woc2.y) / r2;
}
static const float PI = 3.14159265f;
static const float EPSILON = 1e-6f;

float3 Fresnel_Shlick(in float3 f0, in float3 f90, in float x)
{
	return f0 + (f90 - f0) * pow(1.f - x, 5.f);
}
float Diffuse_Burley(in float NdotL, in float NdotV, in float LdotH, in float roughness)
{
	float fd90 = 0.5f + 2.f * roughness * LdotH * LdotH;
	return Fresnel_Shlick(1, fd90, NdotL).x * Fresnel_Shlick(1, fd90, NdotV).x;
}
float Specular_D_GGX(in float alpha, in float NdotH)
{
	const float alpha2 = alpha * alpha;
	const float lower = (NdotH * NdotH * (alpha2 - 1)) + 1;
	return alpha2 / max(EPSILON, PI * lower * lower);
}
float G_Shlick_Smith_Hable(float alpha, float LdotH)
{
	return rcp(lerp(LdotH * LdotH, 1, alpha * alpha * 0.25f));
}
float v_smith1(float alpha, float NdotL, float NdotV)
{
	const float lambdav = NdotL * (NdotV * (1.0 - alpha) + alpha);
	const float lambdal = NdotV * (NdotL * (1.0 - alpha) + alpha);
	return 0.5 / (lambdav + lambdal + 0.0001);
}
float3 Specular_BRDF(in float alpha, in float3 specularColor, in float NdotV, in float NdotL, in float LdotH, in float NdotH)
{
	float specular_D = Specular_D_GGX(alpha, NdotH);
	float3 specular_F = Fresnel_Shlick(specularColor, 1, LdotH);
	float specular_G = G_Shlick_Smith_Hable(alpha, LdotH);
	return specular_D * specular_F * specular_G;
}
float3 LightSurface(in float3 V, in float3 N,
	in float3 albedo, in float metallic, in float roughness, in float clearcoat)
{

	static const float kSpecularCoefficient = 0.04;
	const float NdotV = saturate(dot(N, V));
	const float alpha = roughness * roughness;

	const float3 c_diff = lerp(albedo, float3(0, 0, 0), metallic);
	const float3 c_spec = lerp(kSpecularCoefficient, albedo, metallic);
	float3 acc_color = 0;
	for (int i = 0; i < 3; i++)
	{
		float3 H = normalize(toLightDirection[i] + V);
		float NdotL = saturate(dot(N, toLightDirection[i]));
		float LdotH = saturate(dot(toLightDirection[i], H));
		float NdotH = saturate(dot(N, H));
		float diffuse_factor = Diffuse_Burley(NdotL, NdotV, LdotH, roughness);
		float3 specular = Specular_BRDF(alpha, c_spec, NdotV, NdotL, LdotH, NdotH);
		//float3 specularclear = 0.25 * Specular_D_GGX(0.00506, NdotH) * Fresnel_Shlick(float3(0.04, 0.04, 0.04), 1, LdotH) * G_Shlick_Smith_Hable(0.25, LdotH);
		//acc_color += NdotL * LightColor[i] * ((c_diff * diffuse_factor + specular) + clearcoat * specularclear);
		
		acc_color += NdotL * LightColor[i] * (c_diff * diffuse_factor + specular);
	}
	
	return acc_color;
}
BasicType BasicVS(inputBasicType input){
	BasicType output;
	float4 pos4n0 = 0;
	float4 pos4p0 = 0;
	float4 pos4n1 = 0;
	float4 pos4p1 = 0;

	pos4n0 = float4(input.norm, 0.0);
	pos4p0 = float4(input.pos, 1.0);

	matrix matbone = input.weight0 * animmat[input.joint0] + (1.0 - input.weight0) * animmat[input.joint1];
	pos4n1 = mul(matbone, pos4n0);
	pos4p1 = mul(matbone, pos4p0);
	
	//pos4n1 = input.weight0 * mul(animmat[input.joint0], pos4n0) + (1.0 - input.weight0) * mul(animmat[input.joint1], pos4n0);
	//pos4p1 = input.weight0 * mul(animmat[input.joint0], pos4p0) + (1.0 - input.weight0) * mul(animmat[input.joint1], pos4p0);
	
	float4 vsveca4 = mul(worldMat, pos4p1);
	output.posworld = vsveca4.xyz;
	output.svpos = mul(wvpMat, pos4p1);
	output.uv = input.uv;
	vsveca4 = mul(worldMat, pos4n1);
	output.norm = normalize(vsveca4.xyz);
	output.matno = input.matno;
	return output;
}
BasicTypenm BasicVSnm(inputBasicTypenm input) {
	BasicTypenm output;

	float4 vsveca4 = mul(worldMat, float4(input.pos, 1.0));
	output.posworld = vsveca4.xyz;
	output.svpos = mul(wvpMat, float4(input.pos, 1.0));
	output.uv = input.uv;
	vsveca4 = mul(worldMat, float4(input.norm, 0.0));
	output.norm = normalize(vsveca4.xyz);
	vsveca4 = mul(worldMat, float4(input.uvec, 0.0));
	output.uvec = normalize(vsveca4.xyz);
	vsveca4 = mul(worldMat, float4(input.vvec, 0.0));
	output.vvec = normalize(vsveca4.xyz);
	output.matno = input.matno;
	return output;
}
BasicTypesp VSsprite(uint vID : SV_VertexID)
{
	BasicTypesp output;

	output.svpos = spvtxpos[vID];
	output.uv = spvtxtex[vID].xy;
	return output;
}
BasicTypeptl VSptl(uint vID : SV_VertexID)
{
	BasicTypeptl output;
	output.pos = float3(ptldata[vID * 5 + 3], ptldata[vID * 5 + 4], ptldata[vID * 5 + 5]);
	output.uv = float2(ptldata[vID * 5 + 6], ptldata[vID * 5 + 7]);
	return output;
}

[maxvertexcount(4)]
void GS_PARTICLE(point BasicTypeptl In[1],
	inout TriangleStream<BasicTypesp> ParticleStream)
{
	float4 gsvec4 = mul(worldMat, float4(In[0].pos, 1.0));
	// _ʂɂ
	float4 posLT = gsvec4 + float4(-ptldata[1]* 0.5, ptldata[2] * 0.5, 0.0, 0.0);
	float4 posLB = gsvec4 + float4(-ptldata[1] * 0.5, -ptldata[2] * 0.5, 0.0, 0.0);
	float4 posRT = gsvec4 + float4(ptldata[1] * 0.5, ptldata[2] * 0.5, 0.0, 0.0);
	float4 posRB = gsvec4 + float4(ptldata[1] * 0.5, -ptldata[2] * 0.5, 0.0, 0.0);

	// ̓_̈ʒu(ˉeWn)vZďo
	BasicTypesp output;
	output.svpos = mul(wvpMat, posLT);
	output.uv = float2(In[0].uv.x, In[0].uv.y);
	ParticleStream.Append(output);

	// E̓_̈ʒu(ˉeWn)vZďo
	output.svpos = mul(wvpMat, posRT);
	output.uv = float2(In[0].uv.x + ptldata[0], In[0].uv.y);
	ParticleStream.Append(output);

	// ̓_̈ʒu(ˉeWn)vZďo
	BasicTypesp output1;
	output1.svpos = mul(wvpMat, posLB);
	output1.uv = float2(In[0].uv.x, In[0].uv.y + ptldata[0]);
	ParticleStream.Append(output1);

	// E̓_̈ʒu(ˉeWn)vZďo
	output.svpos = mul(wvpMat, posRB);
	output.uv = float2(In[0].uv.x + ptldata[0], In[0].uv.y + ptldata[0]);
	ParticleStream.Append(output);

	ParticleStream.RestartStrip();
}

float4 BasicPS(BasicType input) : SV_TARGET{
	float3 V = normalize(camerapos - input.posworld);
	//float3 light = normalize(input.posworld - pointlightpos);
	float3 texCoord3ps = 0;
	float4 faceColor4 = 0;
	float3 color = 0;
	float4 mtlrghccw4 = 0;


	switch (input.matno)
	{
	case 0:
		faceColor4 = texdif0.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw0.Sample(smp, input.uv);
		break;
	case 1:
		faceColor4 = texdif1.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw1.Sample(smp, input.uv);
		break;
	case 2:
		faceColor4 = texdif2.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw2.Sample(smp, input.uv);
		break;
	case 3:
		faceColor4 = texdif3.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw3.Sample(smp, input.uv);
		break;
	case 4:
		faceColor4 = texdif4.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw4.Sample(smp, input.uv);
		break;
	default:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		mtlrghccw4 = texmat.Load(texCoord3ps);
		break;
	}
	color = LightSurface(V, input.norm, faceColor4.xyz, mtlrghccw4.x, mtlrghccw4.y, mtlrghccw4.z);
	return float4(color, faceColor4.w);
	
}
float4 BasicPSnm(BasicTypenm input) : SV_TARGET{
	float3 vdzdx = 0;
	float3 vdzdy = 0;
	//float3 light = pointlightpos - input.posworld;
	//float3 R = 0;
	float3 V = normalize(camerapos - input.posworld);
	float3 texCoord3ps = 0;
	float4 faceColor4 = 0;
	float3 color = 0;
	float4 mtlrghccw4 = 0;


	float4 outputcol = 0;
	float4 normcolor = 0;
	float3 normuv = 0;
	float3 normxyz = 0;
	float alpha = 0.0;

	switch (input.matno)
	{
	case 0:
		faceColor4 = texdif0.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw0.Sample(smp, input.uv);
		normcolor = texnorm0.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 1:
		faceColor4 = texdif1.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw1.Sample(smp, input.uv);
		normcolor = texnorm1.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 2:
		faceColor4 = texdif2.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw2.Sample(smp, input.uv);
		normcolor = texnorm2.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 3:
		faceColor4 = texdif3.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw3.Sample(smp, input.uv);
		normcolor = texnorm3.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	case 4:
		faceColor4 = texdif4.Sample(smp, input.uv);
		if ((faceColor4.x == 0.0 && faceColor4.y == 0.0 && faceColor4.z == 0.0) || (faceColor4.w == 0.0)) discard;
		mtlrghccw4 = texmrcw4.Sample(smp, input.uv);
		normcolor = texnorm4.Sample(smp, input.uv);
		normuv = (normcolor - float3(0.5, 0.5, 0.5)) * 2.0;
		break;
	/*case 100:
		vdzdx = float3(1.0, 0.0, dzdx(input.uv.x, input.uv.y));
		vdzdy = float3(0.0, 1.0, dzdy(input.uv.x, input.uv.y));
		normuv = normalize(cross(vdzdx, vdzdy));
		faceColor4 = float4(0.1, 0.1, 0.5, 0.2);
		mtlrghccw4 = float4(0.2, 0.2, 0.2, 0.0);
		break;*/
	default:
		texCoord3ps = float3(input.matno, 0.0, 0);
		faceColor4 = texmat.Load(texCoord3ps);
		texCoord3ps = float3(input.matno, 1.0, 0);
		mtlrghccw4 = texmat.Load(texCoord3ps);
		normuv = float3(0.0, 0.0, 1.0);
		break;
	}
	normxyz = normuv.x * input.uvec - normuv.y * input.vvec + normuv.z * input.norm;
	color = LightSurface(V, normxyz, faceColor4.xyz, mtlrghccw4.x, mtlrghccw4.y, mtlrghccw4.z);
	return float4(color, faceColor4.w);
}
float4 BasicPSsp(BasicTypesp input) : SV_TARGET{
	float4 outputcol = 0;
	outputcol = texdif0.Sample(smp, input.uv);
	if ((outputcol.x == 0.0 && outputcol.y == 0.0 && outputcol.z == 0.0) || (outputcol.w == 0.0)) discard;
	return outputcol;
}